-- these should be initialised as early as possible
m_undis = {} -- main table
m_undis.c2l = {} -- chart to lua tables
m_undis.fakes = {}
m_undis.fps = 1 / 50
m_undis.firstseenbeat = GAMESTATE:GetSongBeat()
m_undis.path = GAMESTATE:GetCurrentSong():GetSongDir()

m_undis.players = {} -- table that contains players and elements
m_undis.origins = {} -- table that contains original values of players and elements

for pn = 1, 2 do
	table.insert(m_undis.players, {}) -- add a table in the players table for players 1 to 2
	table.insert(m_undis.origins, {}) -- add a table in the origins table for players 1 to 2
end

--Scalable ratios. Aren't they great? I think so. -Kid
local undis_height_ratio = SCREEN_HEIGHT/480
local undis_width_ratio = SCREEN_WIDTH/640

return Def.ActorFrame{
	Def.Quad{
		InitCommand=cmd(visible,false),
		OnCommand=cmd(sleep,9e9),
	},

	Def.Quad{
		InitCommand=cmd(visible,false),
		OnCommand=function(self)

		m_undis.insert = function(act1, act2, act3, act4)
			table.insert(m_undis.actions, {act1, act2, act3, act4})
		end

		m_undis.bps = function()
			return 60 / (GAMESTATE:GetSongBPS() * 60)
		end

		m_undis.GetSpeed = function()
			for pn = 1, 2 do--Added check in ModsLevel_Song because 5.2. -Kid
				local a = GAMESTATE:GetPlayerState('PlayerNumber_P' .. pn)
				if a:GetPlayerOptions('ModsLevel_Preferred'):CMod() or a:GetPlayerOptions('ModsLevel_Song'):CMod() then
					Trace('## HEY HEY HEY')
					Trace('## WHAT DO YOU THINK YOU\'RE DOING')
					a:GetPlayerOptions('ModsLevel_Song'):XMod(1, 1)
					a:GetPlayerOptions('ModsLevel_Song'):CMod(150, 1)
					a:GetPlayerOptions('ModsLevel_Song'):Drunk(2, 1)
					a:GetPlayerOptions('ModsLevel_Song'):Dizzy(3.14, 1)
					a:GetPlayerOptions('ModsLevel_Song'):Tipsy(2, 1)
				end
			end
		end

		local m = m_undis.insert
		m_undis.actions = {}

		m(0, 0, function()
			m_undis.GetSpeed()
		end, true)

		m(698, 698, function()
			for pn = 1, 2 do
				local a = m_undis.players[pn]
				if a.p then
					--a.p:decelerate(m_undis.bps())
					a.p:accelerate(1.927)
					a.p:x(m_undis.players[1].p and m_undis.origins[1].p.x or (SCREEN_WIDTH * 0.25))
					--Trace('## ' .. GAMESTATE:GetElapsedTimeFromBeat(698))
				end
			end
		end, true)

		local fluct = 1
		for beat = 709, 3509, 400 do
			local percent = beat
			local p_fluct = fluct
			m(beat, beat, function()
				m_undis.aux:x(1)
				m_undis.aux:decelerate(m_undis.bps() * 400)
				m_undis.aux:x(0.1)
				for pn = 1, 2 do
					local a = GAMESTATE:GetPlayerState('PlayerNumber_P' .. pn):GetPlayerOptions('ModsLevel_Song')
					a:Drunk((percent - 709) * p_fluct / 100, 25)
					a:Tipsy((percent - 709) * p_fluct / 100, 25)
					a:XMod(1, 10000)
					a:CMod(150, 10000)
				end
			end)
			fluct = -fluct
		end

		m(709, 3909, function()
			local rand = {math.random(-250, 250), math.random(-200, 200), math.random(-100, 100), math.random(-100, 100), math.random(-5, 5), math.random(-45, 45)}
			for pn = 1, 2 do
				local a = m_undis.players[pn]
				if a.p then
					--Supposedly, tween overflows happen. I haven't seen that happen, but I'll take precautions. -Kid
					--Oh, and scale things. -Kid
					a.p:stoptweening():x((m_undis.players[1].p and m_undis.origins[1].p.x or (SCREEN_WIDTH * 0.25)) + (rand[1] * m_undis.aux:GetX())*undis_height_ratio)
					a.p:y(m_undis.origins[pn].p.y + (rand[2] * m_undis.aux:GetX())*undis_height_ratio)
					a.p:z(m_undis.origins[pn].p.z + (rand[3] * m_undis.aux:GetX())*undis_width_ratio)
					a.p:zoomz(rand[4] * m_undis.aux:GetX()*undis_width_ratio)
					a.p:skewx(rand[5] / 10 * m_undis.aux:GetX())
					a.p:rotationz(rand[6] * m_undis.aux:GetX())
				end
			end
		end)

		-- original reader by BrotherMojo
		m_undis.reader = function(beat)
			for cur, act in pairs(m_undis.actions) do
				local remove = false
				if beat > m_undis.firstseenbeat + 0.1 then -- hey, not freezing for 30 seconds sounds like a good idea, right?
					if m_undis.firstseenbeat + 0.1 >= act[1] and not act[4] then
						remove = true
					elseif beat >= act[1] then
						act[3]()
						if beat >= act[2] then
							remove = true
						end
						if remove == true then -- when we are done running a mod/function fully, remove the data from the table
							m_undis.actions[cur] = nil
						end
					end
				end
			end
		end

		m_undis.update = function(beat)
			m_undis.reader(beat)
		end

		self:queuecommand('Set');
	end,

	SetCommand=function(self)
		local screen = SCREENMAN:GetTopScreen() -- shortcut to grab the topscreen
		local origin_to_grab = {{'x', 'GetX'}, {'y', 'GetY'}, {'z', 'GetZ'}, {'zoom', 'GetZoom'}} -- list names and function names to use to get the original position of elements
		--Hid more things. -Kid
		local elements_to_visible = {'BPMDisplay', 'Overlay', 'Underlay', 'StageDisplay', 'SongTitle'}

		for pn = 1, 2 do

			if screen:GetChild('PlayerP' .. pn) then -- check if the players exist, otherwise don't do anything that touches the players themselves
				local elements_to_grab = { -- list elements, and names to grab them
					{screen:GetChild('PlayerP' .. pn), 'p'},
					{screen:GetChild('PlayerP' .. pn):GetChild('Judgment'), 'jud'},
					{screen:GetChild('PlayerP' .. pn):GetChild('Combo'), 'com'},
				}

				local player_elements_to_visible = {
					screen:GetChild('ScoreP' .. pn),
					screen:GetChild('LifeP' .. pn),
					screen:GetChild('SongMeterDisplay' .. PlayerNumberToString(pn - 1)),
					screen:GetChild('StepsDisplay' .. PlayerNumberToString(pn - 1)),
					screen:GetChild('LifeMeterBar' .. PlayerNumberToString(pn - 1)),
				}

				for cur_element, element in pairs(elements_to_grab) do
					m_undis.players[pn][element[2]] = element[1] -- name and assign each variable for player related elements
					m_undis.origins[pn][element[2]] = {} -- table that will hold values for original values of specific of each element to each player

					for cur_origin, origin in pairs(origin_to_grab) do
						m_undis.origins[pn][element[2]][origin[1]] = loadstring('return ' .. 'm_undis.players[' .. pn .. '].' .. element[2] .. ':' .. origin[2] .. '()') -- save the original values
						m_undis.origins[pn][element[2]][origin[1]] = m_undis.origins[pn][element[2]][origin[1]]() -- removes the () from the variables
					end
				end

				for cur_element, element in pairs(player_elements_to_visible) do
					if element then
						element:visible(false)
					end
				end
			end
		end

		for cur_element, element in ipairs(elements_to_visible) do
			if screen:GetChild(element) then
				screen:GetChild(element):visible(false)
			end
		end

		self:queuecommand('Update')
	end,

	UpdateCommand=function(self)
		m_undis.update(GAMESTATE:GetSongBeat())
		self:sleep(m_undis.fps)
		self:queuecommand('Update')
	end
	},

	Def.Quad{InitCommand=cmd(visible, false), OnCommand=function(self) m_undis.aux = self end},

}
