local bpmtable = {}

--USAGE: sampletobpm(sample to start calculating , sample to end calculating , sample rate (sample/second) - usually 44100 , how many beats are in the range of the starting sample and ending sample , beat location in {measure, beat, decimal} - this is due to how ACID displays the current beat postition)
local previous
local function sampletobpm(startsample, endsample, samplerate, beatsinrange, beat)
	if startsample == 'prev' then
		startsample = previous
	end

	local bpm = (samplerate / ((endsample - startsample) / beatsinrange)) * 60
	local actbeat = ((beat[1] - 1) * 4) + (beat[2] - 1) + (beat[3] and (beat[3] * (500 / 384) / 100) or 0)
	table.insert(bpmtable, {_type = 'bpm', bpm, actbeat, beat[1], beat[2], (endsample - startsample)})
	previous = endsample
end

local function bpm_insert(bpm, sony_beat, sample_start, sample_end)
	local actual_beat = ((sony_beat[1] - 1) * 4) + (sony_beat[2] - 1) + (sony_beat[3] and (sony_beat[3] * (500 / 384) / 1000) or 0)
	local sample_len = sample_end - sample_start
	table.insert(bpmtable, {_type = 'bpm', bpm, actual_beat, sony_beat[1], sony_beat[2], sample_len, sample_len})
end

local function stop(length_in_sony_beats, sample_rate, sample_start, sample_end)
	local actual_beat = ((length_in_sony_beats[1][1] - 1) * 4) + (length_in_sony_beats[1][2] - 1) + (length_in_sony_beats[2][3] and (length_in_sony_beats[2][3] * (500 / 384) / 1000) or 0)
	local actual_length = (((length_in_sony_beats[2][1] - 1) * 4) + (length_in_sony_beats[2][2] - 1) + (length_in_sony_beats[2][3] and (length_in_sony_beats[2][3] * (500 / 384) / 1000) or 0)) - (((length_in_sony_beats[1][1] - 1) * 4) + (length_in_sony_beats[1][2] - 1) + (length_in_sony_beats[1][3] and (length_in_sony_beats[1][3] * (500 / 384) / 1000) or 0)) -- what the fuck
	local seconds_length = (sample_end - sample_start) / sample_rate
	table.insert(bpmtable, {_type = 'stop', actual_length, actual_beat, seconds_length, sample_start, sample_end})
end

local r = 44100
local s = sampletobpm
local t = bpm_insert


-- bpms
-- please never do this to yourself
-- each of these were manually inputted :gun: :Gun: :shrimp:
s(0, 44100, r, 1, {1, 1})
s('prev', 67399, r, 1, {1, 2})
s('prev', 78898, r, 1, {1, 3})
s('prev', 102067, r, 1, {1, 4})
s('prev', 125216, r, 1, {2, 1})
s('prev', 136865, r, 1, {2, 2})
s('prev', 148536, r, 1, {2, 3})
s('prev', 160024, r, 1, {2, 4})
s('prev', 240524, r, 1, {3, 1})
s('prev', 252333, r, 1, {3, 2})
s('prev', 263635, r, 1, {3, 3})
s('prev', 275317, r, 1, {3, 4})
s('prev', 286798, r, 1, {4, 1})
s('prev', 310101, r, 1, {4, 2})
s('prev', 333252, r, 1, {4, 3})
s('prev', 366791, r, 1, {4, 4})
s('prev', 401926, r, 1, {5, 1})
s('prev', 414338, r, 1, {5, 2})
s('prev', 503633, r, 1, {5, 3})
s('prev', 526828, r, 1, {5, 4})
s('prev', 538480, r, 1, {6, 1})
s('prev', 583662, r, 1, {6, 2})
s('prev', 606824, r, 1, {6, 3})
s('prev', 629991, r, 1, {6, 4})
s('prev', 653141, r, 1, {7, 1})
s('prev', 665036, r, 1, {7, 2})
s('prev', 688527, r, 1, {7, 3})
s('prev', 711687, r, 1, {7, 4})
s('prev', 734833, r, 1, {8, 1})
s('prev', 758002, r, 1, {8, 2})
s('prev', 769732, r, 1, {8, 3})
s('prev', 792798, r, 1, {8, 4})
s('prev', 815917, r, 1, {9, 1})
s('prev', 827601, r, 1, {9, 2})
s('prev', 839094, r, 1, {9, 3})
s('prev', 885531, r, 1, {9, 4})
s('prev', 897012, r, 1, {10, 1})
s('prev', 908685, r, 1, {10, 2})
s('prev', 981306, r, 1, {10, 3})
s('prev', 992841, r, 1, {10, 4})
s('prev', 1004473, r, 1, {11, 1})
s('prev', 1050602, r, 1, {11, 2})
s('prev', 1074861, r, 1, {11, 3})
s('prev', 1097441, r, 1, {11, 4})
s('prev', 1120226, r, 1, {12, 1})
s('prev', 1131682, r, 1, {12, 2})
s('prev', 1154831, r, 1, {12, 3})
s('prev', 1178051, r, 1, {12, 4})
s('prev', 1189679, r, 1, {13, 1})
s('prev', 1201369, r, 1, {13, 2})
s('prev', 1212881, r, 1, {13, 3})
s('prev', 1224425, r, 1, {13, 4})
s('prev', 1235969, r, 1, {14, 1})
s('prev', 1247519, r, 1, {14, 2})
s('prev', 1259063, r, 1, {14, 3})
s('prev', 1270411, r, 1, {14, 4})
s('prev', 1293732, r, 1, {15, 1})
s('prev', 1305424, r, 1, {15, 2})
s('prev', 1316943, r, 1, {15, 3})
s('prev', 1328482, r, 1, {15, 4})
s('prev', 1340025, r, 1, {16, 1})
s('prev', 1351542, r, 1, {16, 2})
s('prev', 1363141, r, 1, {16, 3})
s('prev', 1374646, r, 1, {16, 4})
s('prev', 1386287, r, 1, {17, 1})
s('prev', 1409453, r, 1, {17, 2})
s('prev', 1420970, r, 1, {17, 3})
s('prev', 1432597, r, 1, {17, 4})
s('prev', 1444114, r, 1, {18, 1})
s('prev', 1467408, r, 1, {18, 2})
s('prev', 1490532, r, 1, {18, 3})
s('prev', 1532943, r, 1, {18, 4})
s('prev', 1617335, r, 1, {19, 1})
s('prev', 1663368, r, 1, {19, 2})
s('prev', 1675071, r, 1, {19, 3})
s('prev', 1686078, r, 1, {19, 4})
s('prev', 1698300, r, 1, {20, 1})
s('prev', 1721301, r, 1, {20, 2})
s('prev', 1733158, r, 1, {20, 3})
s('prev', 1744341, r, 1, {20, 4})
s('prev', 1756012, r, 1, {21, 1})
s('prev', 1767618, r, 1, {21, 2})
s('prev', 1778765, r, 1, {21, 3})
s('prev', 1791056, r, 1, {21, 4})
s('prev', 1814039, r, 1, {22, 1})
s('prev', 1825817, r, 1, {22, 2})
s('prev', 1837101, r, 1, {22, 3})
s('prev', 1848355, r, 1, {22, 4})
s('prev', 1860420, r, 1, {23, 1})
s('prev', 1871510, r, 1, {23, 2})
s('prev', 1883563, r, 1, {23, 3})
s('prev', 1906754, r, 1, {23, 4})
s('prev', 1918192, r, 1, {24, 1})
s('prev', 1929677, r, 1, {24, 2})
s('prev', 1941357, r, 1, {24, 3})
s('prev', 1953209, r, 1, {24, 4})
s('prev', 1964096, r, 1, {25, 1})
s('prev', 1976369, r, 1, {25, 2})
s('prev', 1999367, r, 1, {25, 3})
s('prev', 2011015, r, 1, {25, 4})
s('prev', 2022622, r, 1, {26, 1})
s('prev', 2034173, r, 1, {26, 2})
s('prev', 2045750, r, 1, {26, 3})
s('prev', 2058134, r, 1, {26, 4})
s('prev', 2068986, r, 1, {27, 1})
s('prev', 2091881, r, 1, {27, 2})
s('prev', 2103923, r, 1, {27, 3})
s('prev', 2115034, r, 1, {27, 4})
s('prev', 2126777, r, 1, {28, 1})
s('prev', 2138282, r, 1, {28, 2})
s('prev', 2149827, r, 1, {28, 3})
s('prev', 2162274, r, 1, {28, 4})
s('prev', 2184485, r, 1, {29, 1})
s('prev', 2196594, r, 1, {29, 2})
s('prev', 2207974, r, 1, {29, 3})
s('prev', 2247918, r, 1, {29, 4})
s('prev', 2259658, r, 1, {30, 1})
s('prev', 2271811, r, 1, {30, 2})
s('prev', 2282879, r, 1, {30, 3})
s('prev', 2305837, r, 1, {30, 4})
s('prev', 2317630, r, 1, {31, 1})
s('prev', 2329431, r, 1, {31, 2})
s('prev', 2340699, r, 1, {31, 3})
s('prev', 2421830, r, 1, {31, 4})
s('prev', 2433265, r, 1, {32, 1})
s('prev', 2445517, r, 1, {32, 2})
s('prev', 2455860, r, 1, {32, 3})
s('prev', 2536643, r, 1, {32, 4})
s('prev', 2607279, r, 1, {33, 1})
s('prev', 2629813, r, 1, {33, 2})
s('prev', 2653460, r, 1, {33, 3})
s('prev', 2688114, r, 1, {33, 4})
s('prev', 2699741, r, 1, {34, 1})
s('prev', 2768970, r, 1, {34, 2})
s('prev', 2780740, r, 1, {34, 3})
s('prev', 2792655, r, 1, {34, 4})
s('prev', 2804003, r, 1, {35, 1})
s('prev', 2826813, r, 1, {35, 2})
s('prev', 2838789, r, 1, {35, 3})
s('prev', 2873694, r, 1, {35, 4})
s('prev', 2884708, r, 1, {36, 1})
s('prev', 2977728, r, 1, {36, 2})
s('prev', 3001027, r, 1, {36, 3})
s('prev', 3023781, r, 1, {36, 4})
s('prev', 3059030, r, 1, {37, 1})
s('prev', 3070385, r, 1, {37, 2})
s('prev', 3139611, r, 1, {37, 3})
s('prev', 3151400, r, 1, {37, 4})
s('prev', 3162935, r, 1, {38, 1})
s('prev', 3174764, r, 1, {38, 2})
s('prev', 3197751, r, 1, {38, 3})
s('prev', 3209319, r, 1, {38, 4})
s('prev', 3244485, r, 1, {39, 1})
s('prev', 3255610, r, 1, {39, 2})
s('prev', 3385561, r, 1, {39, 3})
s('prev', 3398244, r, 1, {39, 4})
s('prev', 3404498, r, 1, {40, 1})
s('prev', 3417009, r, 1, {40, 2})
s('prev', 3429528, r, 1, {40, 3})
s('prev', 3435904, r, 1, {40, 4})
s('prev', 3442122, r, 1, {41, 1})
s('prev', 3448377, r, 1, {41, 2})
s('prev', 3479758, r, 1, {41, 3})
s('prev', 3486161, r, 1, {41, 4})
s('prev', 3492192, r, 1, {42, 1})
s('prev', 3498447, r, 1, {42, 2})
s('prev', 3504835, r, 1, {42, 3})
s('prev', 3517195, r, 1, {42, 4})
s('prev', 3529749, r, 1, {43, 1})
s('prev', 3536004, r, 1, {43, 2})
s('prev', 3554358, r, 1, {43, 3})
s('prev', 3561133, r, 1, {43, 4})
s('prev', 3585983, r, 1, {44, 1})
s('prev', 3598685, r, 1, {44, 2})
s('prev', 3604941, r, 1, {44, 3})
s('prev', 3617543, r, 1, {44, 4})
s('prev', 3630043, r, 1, {45, 1})
s('prev', 3642514, r, 1, {45, 2})
s('prev', 3655006, r, 1, {45, 3})
s('prev', 3661413, r, 1, {45, 4})
s('prev', 3673906, r, 1, {46, 1})
s('prev', 3686317, r, 1, {46, 2})
s('prev', 3690475, r, 1, {46, 3})
s('prev', 3693834, r, 1, {46, 4})
s('prev', 3697150, r, 1, {47, 1})
s('prev', 3700825, r, 1, {47, 2})
s('prev', 3704328, r, 1, {47, 3})
s('prev', 3707716, r, 1, {47, 4})
s('prev', 3711018, r, 1, {48, 1})
s('prev', 3737154, r, 1, {48, 2})
s('prev', 3740391, r, 1, {48, 3})
s('prev', 3743955, r, 1, {48, 4})
s('prev', 3747271, r, 1, {49, 1})
s('prev', 3750738, r, 1, {49, 2})
s('prev', 3754161, r, 1, {49, 3})
s('prev', 3757564, r, 1, {49, 4})
s('prev', 3760847, r, 1, {50, 1})
s('prev', 3787134, r, 1, {50, 2})
s('prev', 3790418, r, 1, {50, 3})
s('prev', 3793799, r, 1, {50, 4})
s('prev', 3797222, r, 1, {51, 1})
s('prev', 3800682, r, 1, {51, 2})
s('prev', 3804156, r, 1, {51, 3})
s('prev', 3807314, r, 1, {51, 4})
s('prev', 3810846, r, 1, {52, 1})
s('prev', 3837014, r, 1, {52, 2})
s('prev', 3840341, r, 1, {52, 3})
s('prev', 3843872, r, 1, {52, 4})
s('prev', 3847339, r, 1, {53, 1})
s('prev', 3850720, r, 1, {53, 2})
s('prev', 3853921, r, 1, {53, 3})
s('prev', 3857596, r, 1, {53, 4})
s('prev', 3860701, r, 1, {54, 1})
s('prev', 3887044, r, 1, {54, 2})
s('prev', 3890360, r, 1, {54, 3})
s('prev', 3893827, r, 1, {54, 4})
s('prev', 3897229, r, 1, {55, 1})
s('prev', 3900459, r, 1, {55, 2})
s('prev', 3903775, r, 1, {55, 3})
s('prev', 3907565, r, 1, {55, 4})
s('prev', 3910676, r, 1, {56, 1})
s('prev', 3913325, r, 1, {56, 2})
s('prev', 3936839, r, 1, {56, 3})
s('prev', 3940299, r, 1, {56, 4})
s('prev', 3943830, r, 1, {57, 1})
s('prev', 3947365, r, 1, {57, 2})
s('prev', 3950638, r, 1, {57, 3})
s('prev', 3954041, r, 1, {57, 4})
s('prev', 3957400, r, 1, {58, 1})
s('prev', 3960630, r, 1, {58, 2})
s('prev', 3986938, r, 1, {58, 3})
s('prev', 3990161, r, 1, {58, 4})
s('prev', 3993649, r, 1, {59, 1})
s('prev', 3997116, r, 1, {59, 2})
s('prev', 4000518, r, 1, {59, 3})
s('prev', 4003921, r, 1, {59, 4})
s('prev', 4007280, r, 1, {60, 1})
s('prev', 4010553, r, 1, {60, 2})
s('prev', 4013912, r, 1, {60, 3})
s('prev', 4036960, r, 1, {60, 4})
s('prev', 4040297, r, 1, {61, 1})
s('prev', 4043463, r, 1, {61, 2})
s('prev', 4047016, r, 1, {61, 3})
s('prev', 4050396, r, 1, {61, 4})
s('prev', 4053913, r, 1, {62, 1})
s('prev', 4057273, r, 1, {62, 2})
s('prev', 4060546, r, 1, {62, 3})
s('prev', 4072001, r, 1, {62, 4})
s('prev', 4086608, r, 1, {63, 1})
s('prev', 4089989, r, 1, {63, 2})
s('prev', 4093391, r, 1, {63, 3})
s('prev', 4096879, r, 1, {63, 4})
s('prev', 4100196, r, 1, {64, 1})
s('prev', 4103641, r, 1, {64, 2})
s('prev', 4107129, r, 1, {64, 3})
s('prev', 4110273, r, 1, {64, 4})
s('prev', 4113202, r, 1, {65, 1})
s('prev', 4136876, r, 1, {65, 2})
s('prev', 4139841, r, 1, {65, 3})
s('prev', 4143430, r, 1, {65, 4})
s('prev', 4146864, r, 1, {66, 1})
s('prev', 4150396, r, 1, {66, 2})
s('prev', 4153712, r, 1, {66, 3})
s('prev', 4157093, r, 1, {66, 4})
s('prev', 4160269, r, 1, {67, 1})
s('prev', 4171444, r, 1, {67, 2})
s('prev', 4186266, r, 1, {67, 3})
s('prev', 4189819, r, 1, {67, 4})
s('prev', 4192920, r, 1, {68, 1})
s('prev', 4196452, r, 1, {68, 2})
s('prev', 4200155, r, 1, {68, 3})
s('prev', 4203471, r, 1, {68, 4})
s('prev', 4206615, r, 1, {69, 1})
s('prev', 4209845, r, 1, {69, 2})
s('prev', 4212774, r, 1, {69, 3})
s('prev', 4236417, r, 1, {69, 4})
s('prev', 4239583, r, 1, {70, 1})
s('prev', 4243114, r, 1, {70, 2})
s('prev', 4246732, r, 1, {70, 3})
s('prev', 4249919, r, 1, {70, 4})
s('prev', 4253321, r, 1, {71, 1})
s('prev', 4256551, r, 1, {71, 2})
s('prev', 4259996, r, 1, {71, 3})
s('prev', 4271538, r, 1, {71, 4})
s('prev', 4286037, r, 1, {72, 1})
s('prev', 4289425, r, 1, {72, 2})
s('prev', 4293042, r, 1, {72, 3})
s('prev', 4296143, r, 1, {72, 4})
s('prev', 4299703, r, 1, {73, 1})
s('prev', 4303211, r, 1, {73, 2})
s('prev', 4306422, r, 1, {73, 3})
s('prev', 4309810, r, 1, {73, 4})
s('prev', 4312623, r, 1, {74, 1})
s('prev', 4336109, r, 1, {74, 2})
s('prev', 4339612, r, 1, {74, 3})
s('prev', 4342827, r, 1, {74, 4})
s('prev', 4346330, r, 1, {75, 1})
s('prev', 4349431, r, 1, {75, 2})
s('prev', 4352991, r, 1, {75, 3})
s('prev', 4356293, r, 1, {75, 4})
s('prev', 4359250, r, 1, {76, 1})
s('prev', 4371194, r, 1, {76, 2})
s('prev', 4385707, r, 1, {76, 3})
s('prev', 4389023, r, 1, {76, 4})
s('prev', 4392468, r, 1, {77, 1})
s('prev', 4395914, r, 1, {77, 2})
s('prev', 4399416, r, 1, {77, 3})
s('prev', 4402603, r, 1, {77, 4})
s('prev', 4406250, r, 1, {78, 1})
s('prev', 4409839, r, 1, {78, 2})
s('prev', 4412078, r, 1, {78, 3})
s('prev', 4435721, r, 1, {78, 4})
s('prev', 4439167, r, 1, {79, 1})
s('prev', 4442268, r, 1, {79, 2})
s('prev', 4445713, r, 1, {79, 3})
s('prev', 4449201, r, 1, {79, 4})
s('prev', 4452603, r, 1, {80, 1})
s('prev', 4456178, r, 1, {80, 2})
s('prev', 4459365, r, 1, {80, 3})
s('prev', 4470734, r, 1, {80, 4})
s('prev', 4485470, r, 1, {81, 1})
s('prev', 4496323, r, 1, {81, 2})
s('prev', 4523261, r, 1, {81, 3})
s('prev', 4534774, r, 1, {81, 4})
s('prev', 4539641, r, 1, {82, 1})
s('prev', 4546230, r, 1, {82, 2})
s('prev', 4560170, r, 1, {82, 3})
s('prev', 4585321, r, 1, {82, 4})
s('prev', 4591092, r, 1, {83, 1})
s('prev', 4597422, r, 1, {83, 2})
s('prev', 4611031, r, 1, {83, 3})
s('prev', 4635407, r, 1, {83, 4})
s('prev', 4640517, r, 1, {84, 1})
s('prev', 4645944, r, 1, {84, 2})
s('prev', 4659725, r, 1, {84, 3})
s('prev', 4670585, r, 1, {84, 4})
s('prev', 4686204, r, 1, {85, 1})
s('prev', 4692506, r, 1, {85, 2})
s('prev', 4699095, r, 1, {85, 3})
s('prev', 4710701, r, 1, {85, 4})
s('prev', 4736019, r, 1, {86, 1})
s('prev', 4742791, r, 1, {86, 2})
s('prev', 4749294, r, 1, {86, 3})
s('prev', 4760750, r, 1, {86, 4})
s('prev', 4786032, r, 1, {87, 1})
s('prev', 4791831, r, 1, {87, 2})
s('prev', 4797803, r, 1, {87, 3})
s('prev', 4811125, r, 1, {87, 4})
s('prev', 4836060, r, 1, {88, 1})
s('prev', 4842118, r, 1, {88, 2})
s('prev', 4848362, r, 1, {88, 3})
s('prev', 4860722, r, 1, {88, 4})
s('prev', 4871144, r, 1, {89, 1})
s('prev', 4885528, r, 1, {89, 2})
s('prev', 4912280, r, 1, {89, 3})
s('prev', 4935611, r, 1, {89, 4})
s('prev', 4938855, r, 1, {90, 1})
s('prev', 4942186, r, 1, {90, 2})
s('prev', 4945402, r, 1, {90, 3})
s('prev', 4949220, r, 1, {90, 4})
s('prev', 4952579, r, 1, {91, 1})
s('prev', 4955766, r, 1, {91, 2})
s('prev', 4959212, r, 1, {91, 3})
s('prev', 4962226, r, 1, {91, 4})
s('prev', 4973165, r, 1, {92, 1})
s('prev', 4985338, r, 1, {92, 2})
s('prev', 4988296, r, 1, {92, 3})
s('prev', 4991770, r, 1, {92, 4})
s('prev', 4995330, r, 1, {93, 1})
s('prev', 4998603, r, 1, {93, 2})
s('prev', 5002020, r, 1, {93, 3})
s('prev', 5005637, r, 1, {93, 4})
s('prev', 5008853, r, 1, {94, 1})
s('prev', 5012528, r, 1, {94, 2})
s('prev', 5034834, r, 1, {94, 3})
s('prev', 5038251, r, 1, {94, 4})
s('prev', 5041725, r, 1, {95, 1})
s('prev', 5044941, r, 1, {95, 2})
s('prev', 5048443, r, 1, {95, 3})
s('prev', 5052118, r, 1, {95, 4})
s('prev', 5055334, r, 1, {96, 1})
s('prev', 5058492, r, 1, {96, 2})
s('prev', 5061765, r, 1, {96, 3})
s('prev', 5072403, r, 1, {96, 4})
s('prev', 5084289, r, 1, {97, 1})
s('prev', 5087777, r, 1, {97, 2})
s('prev', 5091223, r, 1, {97, 3})
s('prev', 5094711, r, 1, {97, 4})
s('prev', 5098329, r, 1, {98, 1})
s('prev', 5101731, r, 1, {98, 2})
s('prev', 5105176, r, 1, {98, 3})
s('prev', 5108406, r, 1, {98, 4})
s('prev', 5111507, r, 1, {99, 1})
s('prev', 5134533, r, 1, {99, 2})
s('prev', 5137892, r, 1, {99, 3})
s('prev', 5140907, r, 1, {99, 4})
s('prev', 5144467, r, 1, {100, 1})
s('prev', 5147884, r, 1, {100, 2})
s('prev', 5151071, r, 1, {100, 3})
s('prev', 5154717, r, 1, {100, 4})
s('prev', 5158047, r, 1, {101, 1})
s('prev', 5161263, r, 1, {101, 2})
s('prev', 5171628, r, 1, {101, 3})
s('prev', 5183992, r, 1, {101, 4})
s('prev', 5187416, r, 1, {102, 1})
s('prev', 5190689, r, 1, {102, 2})
s('prev', 5194134, r, 1, {102, 3})
s('prev', 5197816, r, 1, {102, 4})
s('prev', 5201133, r, 1, {103, 1})
s('prev', 5204750, r, 1, {103, 2})
s('prev', 5207679, r, 1, {103, 3})
s('prev', 5211540, r, 1, {103, 4})
s('prev', 5233906, r, 1, {104, 1})
s('prev', 5237201, r, 1, {104, 2})
s('prev', 5240711, r, 1, {104, 3})
s('prev', 5244027, r, 1, {104, 4})
s('prev', 5247601, r, 1, {105, 1})
s('prev', 5250724, r, 1, {105, 2})
s('prev', 5254169, r, 1, {105, 3})
s('prev', 5257205, r, 1, {105, 4})
s('prev', 5260370, r, 1, {106, 1})
s('prev', 5272508, r, 1, {106, 2})
s('prev', 5283259, r, 1, {106, 3})
s('prev', 5293983, r, 1, {106, 4})
s('prev', 5321294, r, 1, {107, 1})
s('prev', 5332549, r, 1, {107, 2})
s('prev', 5338492, r, 1, {107, 3})
s('prev', 5344004, r, 1, {107, 4})
s('prev', 5358087, r, 1, {108, 1})
s('prev', 5383410, r, 1, {108, 2})
s('prev', 5389138, r, 1, {108, 3})
s('prev', 5394909, r, 1, {108, 4})
s('prev', 5408173, r, 1, {109, 1})
s('prev', 5433421, r, 1, {109, 2})
s('prev', 5439537, r, 1, {109, 3})
s('prev', 5445609, r, 1, {109, 4})
s('prev', 5456720, r, 1, {110, 1})
s('prev', 5468305, r, 1, {110, 2})
s('prev', 5483866, r, 1, {110, 3})
s('prev', 5490154, r, 1, {110, 4})
s('prev', 5495580, r, 1, {111, 1})
s('prev', 5508845, r, 1, {111, 2})
s('prev', 5533886, r, 1, {111, 3})
s('prev', 5539628, r, 1, {111, 4})
s('prev', 5545629, r, 1, {112, 1})
s('prev', 5558434, r, 1, {112, 2})
s('prev', 5583757, r, 1, {112, 3})
s('prev', 5590303, r, 1, {112, 4})
s('prev', 5596964, r, 1, {113, 1})
s('prev', 5608104, r, 1, {113, 2})
s('prev', 5633928, r, 1, {113, 3})
s('prev', 5640273, r, 1, {113, 4})
s('prev', 5646962, r, 1, {114, 1})
s('prev', 5658762, r, 1, {114, 2})
s('prev', 5669156, r, 1, {114, 3})
s('prev', 5683526, r, 1, {114, 4})
s('prev', 5686626, r, 1, {115, 1})
s('prev', 5690287, r, 1, {115, 2})
s('prev', 5693775, r, 1, {115, 3})
s('prev', 5697178, r, 1, {115, 4})
s('prev', 5700838, r, 1, {116, 1})
s('prev', 5704025, r, 1, {116, 2})
s('prev', 5707729, r, 1, {116, 3})
s('prev', 5719529, r, 1, {116, 4})
s('prev', 5722285, r, 1, {117, 1})
s('prev', 5726362, r, 1, {117, 2})
s('prev', 5729521, r, 1, {117, 3})
s('prev', 5732822, r, 1, {117, 4})
s('prev', 5736210, r, 1, {118, 1})
s('prev', 5739713, r, 1, {118, 2})
s('prev', 5743043, r, 1, {118, 3})
s('prev', 5754714, r, 1, {118, 4})
s('prev', 5758138, r, 1, {119, 1})
s('prev', 5761304, r, 1, {119, 2})
s('prev', 5764857, r, 1, {119, 3})
s('prev', 5767742, r, 1, {119, 4})
s('prev', 5779058, r, 1, {120, 1})
s('prev', 5782180, r, 1, {120, 2})
s('prev', 5785647, r, 1, {120, 3})
s('prev', 5789200, r, 1, {120, 4})
s('prev', 5792581, r, 1, {121, 1})
s('prev', 5796090, r, 1, {121, 2})
s('prev', 5799421, r, 1, {121, 3})
s('prev', 5802924, r, 1, {121, 4})
s('prev', 5814638, r, 1, {122, 1})
s('prev', 5817749, r, 1, {122, 2})
s('prev', 5821281, r, 1, {122, 3})
s('prev', 5824898, r, 1, {122, 4})
s('prev', 5828128, r, 1, {123, 1})
s('prev', 5831531, r, 1, {123, 2})
s('prev', 5834933, r, 1, {123, 3})
s('prev', 5838432, r, 1, {123, 4})
s('prev', 5850089, r, 1, {124, 1})
s('prev', 5853555, r, 1, {124, 2})
s('prev', 5856872, r, 1, {124, 3})
s('prev', 5860295, r, 1, {124, 4})
s('prev', 5863568, r, 1, {125, 1})
s('prev', 5874550, r, 1, {125, 2})
s('prev', 5877662, r, 1, {125, 3})
s('prev', 5881333, r, 1, {125, 4})
s('prev', 5884405, r, 1, {126, 1})
s('prev', 5888253, r, 1, {126, 2})
s('prev', 5891382, r, 1, {126, 3})
s('prev', 5894885, r, 1, {126, 4})
s('prev', 5898072, r, 1, {127, 1})
s('prev', 5910130, r, 1, {127, 2})
s('prev', 5913360, r, 1, {127, 3})
s('prev', 5916763, r, 1, {127, 4})
s('prev', 5920122, r, 1, {128, 1})
s('prev', 5923825, r, 1, {128, 2})
s('prev', 5927098, r, 1, {128, 3})
s('prev', 5930242, r, 1, {128, 4})
s('prev', 5934764, r, 1, {129, 1})
s('prev', 5945517, r, 1, {129, 2})
s('prev', 5948919, r, 1, {129, 3})
s('prev', 5952278, r, 1, {129, 4})
s('prev', 5955982, r, 1, {130, 1})
s('prev', 5959169, r, 1, {130, 2})
s('prev', 5969763, r, 1, {130, 3})
s('prev', 5973381, r, 1, {130, 4})
s('prev', 5976395, r, 1, {131, 1})
s('prev', 5979797, r, 1, {131, 2})
s('prev', 5983501, r, 1, {131, 3})
s('prev', 5986602, r, 1, {131, 4})
s('prev', 5990133, r, 1, {132, 1})
s('prev', 5993557, r, 1, {132, 2})
s('prev', 6005415, r, 1, {132, 3})
s('prev', 6008630, r, 1, {132, 4})
s('prev', 6011918, r, 1, {133, 1})
s('prev', 6015406, r, 1, {133, 2})
s('prev', 6019110, r, 1, {133, 3})
s('prev', 6022383, r, 1, {133, 4})
s('prev', 6025936, r, 1, {134, 1})
s('prev', 6029360, r, 1, {134, 2})
s('prev', 6040787, r, 1, {134, 3})
s('prev', 6044318, r, 1, {134, 4})
s('prev', 6047749, r, 1, {135, 1})
s('prev', 6051036, r, 1, {135, 2})
s('prev', 6054180, r, 1, {135, 3})
s('prev', 6065205, r, 1, {135, 4})
s('prev', 6068629, r, 1, {136, 1})
s('prev', 6072053, r, 1, {136, 2})
s('prev', 6075283, r, 1, {136, 3})
s('prev', 6078900, r, 1, {136, 4})
s('prev', 6082044, r, 1, {137, 1})
s('prev', 6085576, r, 1, {137, 2})
s('prev', 6088892, r, 1, {137, 3})
s('prev', 6101639, r, 1, {137, 4})
s('prev', 6105019, r, 1, {138, 1})
s('prev', 6108572, r, 1, {138, 2})
s('prev', 6111781, r, 1, {138, 3})
s('prev', 6115312, r, 1, {138, 4})
s('prev', 6118887, r, 1, {139, 1})
s('prev', 6121987, r, 1, {139, 2})
s('prev', 6125519, r, 1, {139, 3})
s('prev', 6136199, r, 1, {139, 4})
s('prev', 6139200, r, 1, {140, 1})
s('prev', 6142631, r, 1, {140, 2})
s('prev', 6145875, r, 1, {140, 3})
s('prev', 6160912, r, 1, {140, 4})
s('prev', 6164386, r, 1, {141, 1})
s('prev', 6167745, r, 1, {141, 2})
s('prev', 6170846, r, 1, {141, 3})
s('prev', 6174378, r, 1, {141, 4})
s('prev', 6177737, r, 1, {142, 1})
s('prev', 6181412, r, 1, {142, 2})
s('prev', 6184570, r, 1, {142, 3})
s('prev', 6196535, r, 1, {142, 4})
s('prev', 6199808, r, 1, {143, 1})
s('prev', 6203254, r, 1, {143, 2})
s('prev', 6206642, r, 1, {143, 3})
s('prev', 6210202, r, 1, {143, 4})
s('prev', 6213504, r, 1, {144, 1})
s('prev', 6217179, r, 1, {144, 2})
s('prev', 6220337, r, 1, {144, 3})
s('prev', 6232223, r, 1, {144, 4})
s('prev', 6235324, r, 1, {145, 1})
s('prev', 6238712, r, 1, {145, 2})
s('prev', 6242358, r, 1, {145, 3})
s('prev', 6245746, r, 1, {145, 4})
s('prev', 6249105, r, 1, {146, 1})
s('prev', 6252608, r, 1, {146, 2})
s('prev', 6255737, r, 1, {146, 3})
s('prev', 6259613, r, 1, {146, 4})
s('prev', 6263317, r, 1, {147, 1})
s('prev', 6266619, r, 1, {147, 2})
s('prev', 6270093, r, 1, {147, 3})
s('prev', 6273107, r, 1, {147, 4})
s('prev', 6276983, r, 1, {148, 1})
s('prev', 6280343, r, 1, {148, 2})
s('prev', 6292169, r, 1, {148, 3})
s('prev', 6295327, r, 1, {148, 4})
s('prev', 6298686, r, 1, {149, 1})
s('prev', 6302017, r, 1, {149, 2})
s('prev', 6305318, r, 1, {149, 3})
s('prev', 6308850, r, 1, {149, 4})
s('prev', 6312353, r, 1, {150, 1})
s('prev', 6315884, r, 1, {150, 2})
s('prev', 6327684, r, 1, {150, 3})
s('prev', 6330929, r, 1, {150, 4})
s('prev', 6334374, r, 1, {151, 1})
s('prev', 6337819, r, 1, {151, 2})
s('prev', 6340834, r, 1, {151, 3})
s('prev', 6351888, r, 1, {151, 4})
s('prev', 6355204, r, 1, {152, 1})
s('prev', 6358434, r, 1, {152, 2})
s('prev', 6361836, r, 1, {152, 3})
s('prev', 6365238, r, 1, {152, 4})
s('prev', 6368770, r, 1, {153, 1})
s('prev', 6372086, r, 1, {153, 2})
s('prev', 6375617, r, 1, {153, 3})
s('prev', 6387159, r, 1, {153, 4})
s('prev', 6390561, r, 1, {154, 1})
s('prev', 6394179, r, 1, {154, 2})
s('prev', 6397409, r, 1, {154, 3})
s('prev', 6400854, r, 1, {154, 4})
s('prev', 6404084, r, 1, {155, 1})
s('prev', 6407831, r, 1, {155, 2})
s('prev', 6411233, r, 1, {155, 3})
s('prev', 6422991, r, 1, {155, 4})
s('prev', 6426157, r, 1, {156, 1})
s('prev', 6429731, r, 1, {156, 2})
s('prev', 6432896, r, 1, {156, 3})
s('prev', 6436169, r, 1, {156, 4})
s('prev', 6447259, r, 1, {157, 1})
s('prev', 6450274, r, 1, {157, 2})
s('prev', 6453590, r, 1, {157, 3})
s('prev', 6457272, r, 1, {157, 4})
s('prev', 6460717, r, 1, {158, 1})
s('prev', 6463990, r, 1, {158, 2})
s('prev', 6467522, r, 1, {158, 3})
s('prev', 6471139, r, 1, {158, 4})
s('prev', 6482810, r, 1, {159, 1})
s('prev', 6485997, r, 1, {159, 2})
s('prev', 6489443, r, 1, {159, 3})
s('prev', 6493060, r, 1, {159, 4})
s('prev', 6496549, r, 1, {160, 1})
s('prev', 6499606, r, 1, {160, 2})
s('prev', 6503138, r, 1, {160, 3})
s('prev', 6506540, r, 1, {160, 4})
s('prev', 6518512, r, 1, {161, 1})
s('prev', 6521635, r, 1, {161, 2})
s('prev', 6524800, r, 1, {161, 3})
s('prev', 6528375, r, 1, {161, 4})
s('prev', 6531583, r, 1, {162, 1})
s('prev', 6542551, r, 1, {162, 2})
s('prev', 6545824, r, 1, {162, 3})
s('prev', 6549154, r, 1, {162, 4})
s('prev', 6552599, r, 1, {163, 1})
s('prev', 6555758, r, 1, {163, 2})
s('prev', 6559605, r, 1, {163, 3})
s('prev', 6562935, r, 1, {163, 4})
s('prev', 6566323, r, 1, {164, 1})
s('prev', 6577908, r, 1, {164, 2})
s('prev', 6581483, r, 1, {164, 3})
s('prev', 6584799, r, 1, {164, 4})
s('prev', 6588244, r, 1, {165, 1})
s('prev', 6591646, r, 1, {165, 2})
s('prev', 6595092, r, 1, {165, 3})
s('prev', 6598451, r, 1, {165, 4})
s('prev', 6601681, r, 1, {166, 1})
s('prev', 6613625, r, 1, {166, 2})
s('prev', 6616783, r, 1, {166, 3})
s('prev', 6620343, r, 1, {166, 4})
s('prev', 6623788, r, 1, {167, 1})
s('prev', 6627463, r, 1, {167, 2})
s('prev', 6638259, r, 1, {167, 3})
s('prev', 6641187, r, 1, {167, 4})
s('prev', 6644618, r, 1, {168, 1})
s('prev', 6647891, r, 1, {168, 2})
s('prev', 6651595, r, 1, {168, 3})
s('prev', 6654868, r, 1, {168, 4})
s('prev', 6658270, r, 1, {169, 1})
s('prev', 6661629, r, 1, {169, 2})
s('prev', 6674449, r, 1, {169, 3})
s('prev', 6677808, r, 1, {169, 4})
s('prev', 6681167, r, 1, {170, 1})
s('prev', 6684498, r, 1, {170, 2})
s('prev', 6688373, r, 1, {170, 3})
s('prev', 6691532, r, 1, {170, 4})
s('prev', 6695034, r, 1, {171, 1})
s('prev', 6698049, r, 1, {171, 2})
s('prev', 6709117, r, 1, {171, 3})
s('prev', 6712175, r, 1, {171, 4})
s('prev', 6715448, r, 1, {172, 1})
s('prev', 6718613, r, 1, {172, 2})
s('prev', 6733514, r, 1, {172, 3})
s('prev', 6736830, r, 1, {172, 4})
s('prev', 6740405, r, 1, {173, 1})
s('prev', 6743678, r, 1, {173, 2})
s('prev', 6747123, r, 1, {173, 3})
s('prev', 6750547, r, 1, {173, 4})
s('prev', 6754078, r, 1, {174, 1})
s('prev', 6757244, r, 1, {174, 2})
s('prev', 6769475, r, 1, {174, 3})
s('prev', 6772633, r, 1, {174, 4})
s('prev', 6775992, r, 1, {175, 1})
s('prev', 6779524, r, 1, {175, 2})
s('prev', 6782883, r, 1, {175, 3})
s('prev', 6786357, r, 1, {175, 4})
s('prev', 6789917, r, 1, {176, 1})
s('prev', 6793046, r, 1, {176, 2})
s('prev', 6805105, r, 1, {176, 3})
s('prev', 6808120, r, 1, {176, 4})
s('prev', 6811637, r, 1, {177, 1})
s('prev', 6814953, r, 1, {177, 2})
s('prev', 6818814, r, 1, {177, 3})
s('prev', 6823379, r, 1, {177, 4})
s('prev', 6864508, r, 1, {178, 1})
s('prev', 6984841, r, 400, {178, 2})
s('prev', 7106667, r, 400, {278, 2})
s('prev', 7228022, r, 400, {378, 2})
s('prev', 7349191, r, 400, {478, 2})
s('prev', 7471302, r, 400, {578, 2})
s('prev', 7593676, r, 400, {678, 2})
s('prev', 7715231, r, 400, {778, 2})
s('prev', 7836545, r, 400, {878, 2})
s('prev', 12348000, r, 16, {978, 2})
t(160, {982, 2}, 12348000, 13340250)

local function table_compare(a, b)
	return a[2] < b[2]
end
		
if #bpmtable > 1 then
	table.sort(bpmtable, table_compare)
end

local str = ''
local stop_str = ''
local stop_total = 0
for i, curbpm in pairs(bpmtable) do
	if curbpm._type == 'stop' then
		print('## stop at: ' .. string.format('%f', curbpm[2] - stop_total) .. '\t-- length: ' .. string.format('%f', curbpm[1])  .. '\t-- total: ' .. string.format('%f', stop_total) .. '\n')
		stop_str = stop_str .. curbpm[2] - stop_total .. '=' .. curbpm[3] .. ',\n'

		stop_total = stop_total + curbpm[1]
	end
	if curbpm._type == 'bpm' then
		--print('## beat without stops: ' .. string.format('%f', curbpm[2]) .. '\t-- beat with stops: ' .. string.format('%f', curbpm[2] - stop_total) .. '\t-- bpm: ' .. string.format('%f', curbpm[1]) .. '\t-- location: {' .. curbpm[3] .. ', ' .. curbpm[4] .. '}\t-- sample size: ' .. curbpm[5])
		print('## beat: ' .. string.format('%g', curbpm[2]) .. '\t-- bpm: ' .. string.format('%f', curbpm[1]) .. '\t-- location: {' .. curbpm[3] .. ', ' .. curbpm[4] .. '}\t-- sample size: ' .. curbpm[5])

		str = str .. curbpm[2] - stop_total .. '=' .. curbpm[1] .. ',\n'
	end
end

--print('#BPMS:' .. str .. ';')


io.write('\n## Save BPMs (y/n)?\n> ')
--local ans = io.read()
if string.lower(io.read()) == 'y' then
	io.write('\n## Filename\n> ')
	local ans = io.read()
	local file = io.open('./' .. ans .. '.txt', 'w')
	file:write('#BPMS:' .. str .. ';\n')
	file:write('#STOPS:' .. stop_str .. ';\n')
	file:close()
	print('## BPMs and STOPS saved in ./'.. ans ..'.txt')
end

